DEFINT A-Z
DECLARE SUB I00TO0F (thebyte%)
DECLARE SUB modRM (thebyte%, textreg$, textmem$)

DIM SHARED byte AS STRING * 1
DIM SHARED textregchoices$(0 TO 7)
DIM SHARED textmemchoices$(0 TO 7)

FOR i = 0 TO 7
  READ textmemchoices$(i)
NEXT

OPEN "gen00-0f.com" FOR BINARY AS 1
CLS
DO
  GET 1, , byte
  I00TO07 ASC(byte)
  I08TO0F ASC(byte)
IF CSRLIN = 18 THEN
DO: LOOP UNTIL INKEY$ <> ""
CLS
END IF
LOOP UNTIL EOF(1)
ea:
DATA BX+SI,BX+DI,BP+SI,BP+DI,SI,DI,BP,BX
r8:
DATA AL,CL,DL,BL,AH,CH,DH,BH
r16:
DATA AX,CX,DX,BX,SP,BP,SI,DI
first3t0oto5o:
DATA ADD, OR, ADC, SBB, AND, SUB, XOR, CMP
SUB I00TO07(thebyte%)
    SELECT CASE ASC(byte)
    CASE 0
      RESTORE r8
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textmem$ + ", " + textreg$
    CASE 1
      RESTORE r16
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textmem$ + ", " + textreg$
    CASE 2
      RESTORE r8
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textreg$ + ", " + textmem$
    CASE 3
      RESTORE r16
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textreg$ + ", " + textmem$
    CASE 4
      GET 1, , byte
      ? "ADD AL, "+ ASC(Byte)
    CASE 5
      GET 1, , word%'whether signed or not depends on use by other opcodes
      ? "ADD AX, "+"0"+word%+"H"
    CASE 6
      ?"PUSH ES"
    CASE 7
    ?"POP ES"

    END SELECT
END SUB

SUB I08TO0F(thebyte%)
    SELECT CASE ASC(byte)
    CASE 8
      RESTORE r8
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT " " + textmem$ + ", " + textreg$
    CASE 9
      RESTORE r16
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textmem$ + ", " + textreg$
    CASE &HA
      RESTORE r8
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textreg$ + ", " + textmem$
    CASE &HB
      RESTORE r16
      GET 1, , byte
      modRM ASC(byte), textreg$, textmem$
      PRINT "ADD " + textreg$ + ", " + textmem$
    CASE &HC
      GET 1, , byte
      ? "ADD AL, "+ ASC(Byte)
    CASE &HD
      GET 1, , word%'whether signed or not depends on use by other opcodes
      ? "ADD AX, "+"0"+word%+"H"
    CASE &HE
      ?"PUSH ES"
    CASE &HF
    ?"POP ES"

    END SELECT
END SUB

SUB modRM (thebyte%, textreg$, textmem$)
'mod R/M byte follows opcode and specifies operand;
'operand is either a general register or a memory address;
'if it is a memory address, the address is computed from a segment register
'and any of the following values:
'a base register, an index register, a scaling factor, a displacement
'Reg field of mod R/M selects a general register
   FOR i = 0 TO 7
     READ textregchoices$(i)
   NEXT
   SELECT CASE &HC0 AND thebyte%'mod
   CASE 0
     IF (thebyte% AND 7) = 6 THEN
       GET 1, , uword%
       textmem$ = HEX$(uword%)
     ELSE
       textmem$ = textmemchoices$(thebyte% AND 7)
     END IF
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
     textmem$ = "[" + textmem$ + "]"
   CASE &H40
     GET 1, , byte
     textmem$ = textmemchoices$(thebyte% AND 7) + "+" + HEX$(ASC(byte))
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
     textmem$ = "[" + textmem$ + "]"
   CASE &H80
     GET 1, , uword%
     textmem$ = textmemchoices$(thebyte% AND 7) + "+" + HEX$(uword%)
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
     textmem$ = "[" + textmem$ + "]"
   CASE &HC0
     textmem$ = textregchoices$(thebyte% AND 7)
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
   END SELECT
   
END SUB

