' Guess The Animal   Version 1.0
'
' The purpose of the game is to guess an animal that the computer
' doesn't know. If it doesn't know it, it will ask for a question
' that would distinguish it from a particular animal. The more
' times you play, the harder it will get, because it saves animals
' in a data file called animals.dat
'
' If anyone uses it for a while and builds up a good database,
' e-mail it to me and I'll post it on my site. Even if you don't,
' drop me a line to tell me where you got this, I'd appreciate it.
'
' Address: Daniel Fletcher
'          XYZZY Productions
'          P.O. Box 208
'          Taberg, NY  13471-0208
'
' E-Mail: danielfletcher@cyberdude.com   {E-Mail me for updates
'         xyzzyproductions@hotmail.com    to automatically be sent
'         camdenhighschool@hotmail.com    to you.}
'
' Web site: http://www.geocities.com/SiliconValley/Vista/3048/
'
' Birthday: 7-15-1981

DECLARE SUB Center (row%, text$)
RESTORE
1 DIM SEL$(100), A$(200), Z(100)
50 REM Main Program
60 COLOR 15, 1: CLS : Center 1, "Guess The Animal"
70 PRINT
80 GOSUB 3000
90 REM
100 REM
110 N = VAL(A$(0))
120 REM Main Control Section
130 COLOR 15, 1: CLS : Center 1, "Guess The Animal"
140 PRINT : PRINT
150 REM
160 K = 1
170 GOSUB 390
180 IF LEN(A$(K)) = 0 THEN 1000
190 IF LEFT$(A$(K), 2) = "\Q" THEN 170
200 PRINT "   Is it a "; RIGHT$(A$(K), LEN(A$(K)) - 2);
210 INPUT A$: A$ = UCASE$(A$)
215 A$ = LEFT$(A$, 1)
220 IF A$ <> "Y" AND A$ <> "N" THEN 210
230 IF A$ = "Y" THEN 1000
240 INPUT "   The animal you were thinking of was a"; V$
250 PRINT "   Please type in a question that would distinguish a"
260 PRINT "   "; V$; " from a "; RIGHT$(A$(K), LEN(A$(K)) - 2);
270 INPUT X$
280 PRINT "   For a "; V$; " the answer would be ";
290 INPUT A$: A$ = UCASE$(A$)
295 A$ = LEFT$(A$, 1)
300 IF A$ <> "Y" AND A$ <> "N" THEN 290
305 PRINT A$
310 IF A$ = "Y" THEN B$ = "N"
320 IF A$ = "N" THEN B$ = "Y"
330 Z1 = VAL(A$(0))
340 A$(0) = STR$(Z1 + 2)
350 A$(Z1) = A$(K)
360 A$(Z1 + 1) = "\A" + V$
370 A$(K) = "\Q" + X$ + "\" + A$ + STR$(Z1 + 1) + "\" + B$ + STR$(Z1) + "\"
380 GOTO 120
390 REM
400 Q$ = A$(K)
410 PRINT "   "; : FOR Z = 3 TO LEN(Q$)
415 IF MID$(Q$, Z, 1) = "\" THEN GOTO 420 ELSE PRINT MID$(Q$, Z, 1);
417 NEXT Z
420 INPUT C$: C$ = UCASE$(C$)
430 C$ = LEFT$(C$, 1)
440 IF C$ <> "Y" AND C$ <> "N" THEN 410
450 T$ = "\" + C$
455 FOR X = 3 TO LEN(Q$) - 1
460 IF MID$(Q$, X, 2) = T$ THEN 480
470 NEXT X
475 STOP
480 FOR Y = X + 1 TO LEN(Q$)
490 IF MID$(Q$, Y, 1) = "\" THEN 510
500 NEXT Y
505 STOP
510 K = VAL(MID$(Q$, X + 2, Y - X - 2))
520 RETURN
530 DATA "4","\qDoes it swim\Y2\N3\","\AFISH","\ABIRD"
1000 PRINT
1010 COLOR 4
1020 Center 20, "[Space] Play Again/[ESC] Quit"
1030 A$ = INKEY$
1040 IF A$ = " " THEN 120 ELSE IF A$ = CHR$(27) THEN 2000 ELSE 1030
2000 OPEN "ANIMALS.DAT" FOR OUTPUT AS #1
2010 PRINT #1, A$(0)
2020 FOR A = 1 TO VAL(A$(0))
2030 PRINT #1, A$(A)
2040 NEXT A
2050 CLOSE
2060 SYSTEM
3000 OPEN "ANIMALS.DAT" FOR APPEND AS #1: CLOSE #1
3005 OPEN "ANIMALS.DAT" FOR INPUT AS #1
3010 INPUT #1, A$(0)
3020 FOR A = 1 TO VAL(A$(0))
3030 INPUT #1, A$(A)
3040 NEXT A
3050 CLOSE
3060 RETURN

DEFINT A-Z
'Center:
'  Centers text on given row
SUB Center (row, text$)
    LOCATE row, 41 - LEN(text$) / 2
    PRINT text$;
END SUB

