DECLARE SUB SelectDatabase ()

'AUTH.BAS
'This one doesn't ask you what you are thinking it tells you
'Created to prevent accidental changes to the database/
'dealing with the hassle of being requested to make a change when
'launching multiple sessions and you already know you don't want
'to make changes


'This is a slightly mmodified version of Jim Little's Animal that allows you
'to more easily select different databases to query
'This code is not copyrighted.  However, if you use this code without major
' modifications, Jim Little credit.

'This code implements an old "Intelligence Imitating" algorithm I (Jim Little)
' first saw on the Apple II.  Undoubtably, the routine goes back farther than
' that.  I've (Jim Little) never seen it on the IBM, though, and thought it
' may be of interest.
' (Robert Claypool) Creative computing had a version of it for the PC
'(Jim Little)
'This was thrown together at 3:00 AM.. please excuse the poor design.

'What does it do?  Run it and find out!

DECLARE SUB Intro ()
DECLARE SUB Main ()
DECLARE SUB GetChoice (choice%)
DECLARE SUB InitializeData ()

TYPE animal
   yes AS INTEGER
   no AS INTEGER
   animal AS STRING * 80
END TYPE

CONST cAssign = 1
CONST cRetrieve = 2

CONST False = 0
CONST True = NOT False

DIM SHARED Filename$
SelectDatabase

Intro
DO: K$ = INKEY$: LOOP UNTIL LEN(K$)
DO UNTIL K$ = CHR$(27)
   VIEW PRINT 5 TO 25
   Main
   VIEW PRINT 1 TO 25
   Intro
   DO: K$ = INKEY$: LOOP UNTIL LEN(K$)
LOOP

END

SUB GetChoice (choice%)
'gets a y/n response from the user and returns it as -1 (for y) or 0 (for n)

LOCATE , , 1

DO
   K$ = INKEY$
LOOP WHILE UCASE$(K$) <> "Y" AND UCASE$(K$) <> "N"
choice% = (UCASE$(K$) = "Y")
PRINT K$;

LOCATE , , 0

END SUB

SUB Intro

CLS
PRINT TAB(37); "Query"
PRINT
PRINT
PRINT "Think of an object, and I will attempt to guess it.  As you play, I will"
PRINT "learn more objects,  Eventually, I will know every common object."
PRINT
PRINT "Press any key when you've thought of an object, or ESC to quit."

END SUB

SUB Main
'This is the main program driver.

DIM animalnum&       'animal/question being checked/asked
DIM animal AS animal
DIM usersanimal$     'the user's animal/question
DIM companimal$      'the computer's animal/question
DIM newanimal AS animal  'new animal being added to data
DIM choice%          'yes or no response from user (yes is -1,  no is 0)
DIM records&         'number of records in ANIMAL.DAT

OPEN Filename$ FOR RANDOM AS #1 LEN = LEN(animal)
IF LOF(1) = 0 THEN
   PRINT "This is an empty database."
   PRINT "Press ESC to exit"
   DO
   LOOP UNTIL CHR$(27) = INKEY$
END IF

CLS
animalnum& = 1
GET #1, animalnum&, animal
companimal$ = RTRIM$(animal.animal$)
'It appears the first record can never be an object
DO
   IF animal.yes <> -1 THEN 'question, not animal
     'wait a minute here, the loop test below would insure that
     'animal.yes could never be -1, wouldn't it?
      PRINT companimal$; " ";
      GetChoice choice%
      PRINT : PRINT
      IF choice% THEN  'choice = 'YES'
         animalnum& = animal.yes
      ELSE  'choice = 'NO'
         animalnum& = animal.no
      END IF
   END IF
   GET #1, animalnum&, animal
   companimal$ = RTRIM$(animal.animal$)
LOOP UNTIL animal.yes = -1

PRINT "The item is "; companimal$; ". ";
   PRINT "(Press a key)"
   DO: LOOP UNTIL LEN(INKEY$)
   CLOSE #1

END SUB

SUB SelectDatabase
    FILES "*.DAT"
    PRINT "Please select a database (do not give extension)"
    INPUT Filename$
    Filename$ = Filename$ + ".DAT"
END SUB

