DEFINT A-Z

TYPE InstInfo
    InstType AS INTEGER
    InstLen AS INTEGER
    InstReloc AS INTEGER
END TYPE



CONST Datar8 = 1
CONST Datar16 = 2
CONST DataGroup6 = 3
CONST DataGroup7 = 4
CONST DataJcond = 5
DECLARE SUB NAVOCECTOEF (thebyte%)
DECLARE SUB NAVOCE8TOEA (thebyte%, II AS InstInfo)
DECLARE SUB NAVOC70TO7F (thebyte%)
DECLARE SUB NAVOCF8TOFD (thebyte%)
DECLARE SUB NAVOC60TO61 (thebyte%)
DECLARE SUB NAVOCD4TOD5 (thebyte%)
DECLARE SUB NAVOC40TO5F (thebyte%)
DECLARE SUB GetData (StringData$)
DECLARE SUB DATArESTORE (RestorePoint%)


DECLARE SUB NAVOC (II AS InstInfo, Offset&)
DECLARE SUB NAVOC00TO3F (thebyte%)
DECLARE SUB NAVOC0F ()

DECLARE SUB SO (override%)

DECLARE SUB modRM (thebyte%)

COMMON SHARED /Disasm/ InMem%, inst$, textreg$, textmem$, rfirst%, SegName$
COMMON SHARED /DisasmPermText/ textmemchoices$(), textfirst30$(), textPushSEG$()
COMMON SHARED /DisasmByte/ Byte AS STRING * 1

DIM SHARED textregchoices$(0 TO 7)
DIM SHARED textmemchoices$(0 TO 7)
DIM SHARED textfirst30$(0 TO 7)
DIM SHARED textPushSEG$(0 TO 3)

SUB NAVOC (II AS InstInfo, Offset&)
  II.InstType = 0
  II.InstLen = 0
  II.InstReloc = 0
  GET 1, , Byte
  'Byte is shared so copy it to thebyte%
  thebyte% = ASC(Byte)
  NAVOC00TO3F thebyte%
  NAVOC40TO5F thebyte%
  NAVOC60TO61 thebyte%
  NAVOC70TO7F thebyte%
  NAVOCECTOEF thebyte%
  NAVOCD4TOD5 thebyte%
  NAVOCE8TOEA thebyte%, II
  NAVOCF8TOFD thebyte%

END SUB

SUB NAVOC00TO3F (thebyte%)
    IF thebyte% > &H3F THEN EXIT SUB
    SELECT CASE thebyte% AND 7
    CASE 0
      DATArESTORE Datar8
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT textfirst30$((thebyte% AND &H38) / &H8) + " " + textmem$ + ", " + textreg$
    CASE 1
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT textfirst30$((thebyte% AND &H38) / &H8) + " " + textmem$ + ", " + textreg$
    CASE 2
      DATArESTORE Datar8
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT textfirst30$((thebyte% AND &H38) / &H8) + " " + textreg$ + ", " + textmem$
    CASE 3
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT textfirst30$((thebyte% AND &H38) / &H8) + " " + textreg$ + ", " + textmem$
    CASE 4 'AH, Immediate
      GET 1, , Byte
      PRINT textfirst30$((thebyte% AND &H38) / &H8) + " AL, 0" + HEX$(ASC(Byte)) + "H"
    CASE 5 'AX, Immediate
      GET 1, , word%'whether signed or not depends on use by other opcodes
      PRINT textfirst30$((thebyte% AND &H38) / &H8) + " AX, " + "0" + HEX$(word%) + "H"
    CASE 6
      IF thebyte% AND &H20 THEN
         'SO thebyte% 'unreachable
      ELSE
        PRINT "PUSH " + textPushSEG$((thebyte% AND &H18) / 8)
      END IF
    CASE 7
      IF thebyte% AND &H28 THEN
         SELECT CASE thebyte% AND &H18
         CASE 0
           PRINT "DAA"
         CASE 8
           PRINT "DAS"
         CASE &H10
           PRINT "AAA"
         CASE &H18
           PRINT "AAS"
         END SELECT
      ELSEIF thebyte = &HF THEN
        NAVOC0F
      ELSE
        PRINT "POP " + textPushSEG$((thebyte% AND &H18) / 8)
      END IF
    END SELECT
END SUB

SUB NAVOC0F
    'called by OC00TO3F
    GET 1, , Byte
    SELECT CASE ASC(Byte)
    CASE 0
      DATArESTORE DataGroup6
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT textreg$ + " " + textmem$
    CASE 1
      DATArESTORE DataGroup7
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT textreg$ + " " + textmem$
    CASE 2
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "LAR " + textmem$ + ", " + textreg$
    CASE 3
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "LSL " + textmem$ + ", " + textreg$
    CASE 4
      PRINT "INVALID"
    CASE 5

    END SELECT
END SUB

SUB NAVOC40TO5F (thebyte%)
    IF (thebyte% < &H40) OR (thebyte% > &H5F) THEN EXIT SUB
    DATArESTORE Datar16
    FOR i = 0 TO 7
      GetData textregchoices$(i)
    NEXT
    SELECT CASE thebyte% AND &H50
    CASE &H40
      IF thebyte% AND &H8 THEN
        PRINT "DEC " + textregchoices$(thebyte% AND &H7)
      ELSE
        PRINT "INC " + textregchoices$(thebyte% AND &H7)
      END IF
    CASE &H50
      IF thebyte% AND &H8 THEN
        PRINT "POP " + textregchoices$(thebyte% AND &H7)
      ELSE
        PRINT "PUSH " + textregchoices$(thebyte% AND &H7)
      END IF
    END SELECT
END SUB

SUB NAVOC60TO61 (thebyte%)
    IF (thebyte% < &H60) OR (thebyte% > &H61) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &H60
      PRINT "PUSHA"
    CASE &H61
      PRINT "POPA"
    END SELECT
END SUB

SUB NAVOC62 (thebyte%)
END SUB

SUB NAVOC70TO7F (thebyte%)
    IF (thebyte% < &H70) OR (thebyte% > &H7F) THEN EXIT SUB
    DIM textJcond$(0 TO 15)
    DATArESTORE DataJcond
    FOR i = 0 TO 15
      GetData textJcond$(i)
    NEXT
    GET 1, , Byte
    PRINT textJcond$(thebyte% AND &HF) + " " + HEX$(ASC(Byte))
END SUB

SUB NAVOCA0TOA3 (thebyte%)
    IF (thebyte% < &HA0) OR (thebyte% > &HA3) THEN EXIT SUB
    GET 1, , word%
    SELECT CASE thebyte%
    CASE &HA0
      PRINT "MOV AL, [" + HEX$(word%) + "]"
    CASE &HA1
      PRINT "MOV AX, [" + HEX$(word%) + "]"
    CASE &HA2
      PRINT "MOV [" + HEX$(word%) + "], AX"
    CASE &HA3
      PRINT "MOV [" + HEX$(word%) + "], AL"
    END SELECT
END SUB

SUB NAVOCCB (thebyte%)
    IF thebyte% <> &HCB THEN EXIT SUB
    PRINT "RETF"
END SUB

SUB NAVOCD4TOD5 (thebyte%)
    IF (thebyte% < &HD4) OR (thebyte% > &HD7) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &HD4
      PRINT "AAM"
    CASE &HD5
      PRINT "AAD"
    CASE &HD6
      PRINT "INVALID"
    CASE &HD7
      PRINT "XLAT"
    END SELECT
END SUB

SUB NAVOCE4TOE7 (thebyte%)
    IF (thebyte% < &HE4) OR (thebyte% > &HE7) THEN EXIT SUB
    GET 1, , Byte
    SELECT CASE thebyte%
    CASE &HE4
      PRINT "IN AL, " + HEX$(ASC(Byte))
    CASE &HE5
      PRINT "IN AX, " + HEX$(ASC(Byte))
    CASE &HE6
      PRINT "OUT " + HEX$(ASC(Byte)) + ", AL"
    CASE &HE7
      PRINT "OUT " + HEX$(ASC(Byte)) + ", AX"
    END SELECT
END SUB

SUB NAVOCE8TOEA (thebyte%, II AS InstInfo)
    IF (thebyte% < &HE8) OR (thebyte% > &HEA) THEN EXIT SUB
    GET 1, , word%
    SELECT CASE thebyte%
    CASE &HE8
      PRINT "CALL " + HEX$(word%)

    CASE &HE9
      II.InstType = 1
      II.InstLen = 3
      II.InstReloc = word%
      PRINT "JMP " + HEX$(word%);
    CASE &HEA
      GET 1, , word2%
      PRINT "JMP " + HEX$(word2%) + ":" + HEX$(word%)
    END SELECT
END SUB

SUB NAVOCECTOEF (thebyte%)
    IF (thebyte% < &HEC) OR (thebyte% > &HEF) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &HEC
      PRINT "IN AL, DX"
    CASE &HED
      PRINT "IN AX, DX"
    CASE &HEE
      PRINT "OUT AL, DX"
    CASE &HEF
      PRINT "OUT AX, DX"
    END SELECT
END SUB

SUB NAVOCF8TOFD (thebyte%)
    IF (thebyte% < &HF8) OR (thebyte% > &HFA) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &HF8
      PRINT "CLC"
    CASE &HF9
      PRINT "STC"
    CASE &HFA
      PRINT "CLI"
    CASE &HFB
      PRINT "STI"
    CASE &HFC
      PRINT "CLD"
    CASE &HFD
      PRINT "STD"
    END SELECT
END SUB

