DEFINT A-Z
 
DECLARE FUNCTION FormatInt$ (IntInt%, Format%)
DECLARE FUNCTION FormatLong$ (LongLong&, Format%)
DECLARE FUNCTION Parse1$ (ByteInt%, IntInt%)
DECLARE FUNCTION LongHex$ (Value%, Length%)
 
  DIM Byte AS STRING * 1
  OPEN "TEMP.BIN" FOR BINARY AS #1
  GET 1, , Byte
  SELECT CASE ASC(Byte)
  CASE 0, 1, 2, 3 'ADD
    ByteOri% = ASC(Byte)
  CASE 4 'ADD
    GET 1, , Byte
    PRINT "ADD   AL, " + HEX$(ASC(Byte))
  CASE 5 'ADD
     GET 1, , Integ%
     PRINT "ADD   AX, " + HEX$(Integ)
  CASE 6
     PRINT "PUSH ES"
  CASE 7
     PRINT "POP  ES"
  CASE 8
     GET 1, , Byte
     IF (ASC(Byte) AND 7) = 6 THEN GET 1, , IntInt%
     PRINT "OR " + Parse1$((ASC(Byte) AND 7), IntInt%) + ", AL"
  CASE 9, 10, 11 'OR
             ByteOri% = ASC(Byte)
        CASE 12
             GET 1, , Byte
             PRINT "OR  AL, " + HEX$(ASC(Byte))
        CASE 13
             GET 1, , Integ%
             PRINT "OR   AX, " + HEX$(Integ)
        CASE 14
             PRINT "PUSH CS"
        CASE 15
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE 0
                         GET 1, , Byte
                    CASE ELSE
             END SELECT
        CASE 22
             PRINT "PUSH SS"
        CASE &H1F
             PRINT "POP DS"
        CASE &H2B
              GET 1, , Byte
              SELECT CASE ASC(Byte)
                     CASE &HF7
                          PRINT "SUB SI,DI"
                     CASE ELSE
                     PRINT "2B " + HEX$(ASC(Byte))
              END SELECT
        CASE &H33
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HC0
                         PRINT "XOR AX, AX"
                    CASE &HED
                         PRINT "XOR BP, BP"
                    CASE &HFF
                         PRINT "XOR DI, DI"
                    CASE ELSE
                         PRINT "33 " + HEX$(ASC(Byte))
             END SELECT
        CASE &H36
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HC7
                         GET 1, , Byte
                         SELECT CASE ASC(Byte)
                                CASE &H6
                                     GET 1, , Integ%
                                     GET 1, , Integ2%
                                     PRINT "MOV   SS:[" + HEX$(Integ%) + "], " + HEX$(Integ2%)
                                CASE ELSE
                                     PRINT "36 C7 " + HEX$(ASC(Byte))
                         END SELECT
                    CASE ELSE
                         PRINT "36 " + HEX$(ASC(Byte))
             END SELECT
        CASE &H3C
             GET 1, , Byte
             PRINT "CMP  AL, " + HEX$(ASC(Byte))
        CASE &H3D
             GET 1, , Integ%
             PRINT "CMP  AX, " + LongHex(Integ, 4)
        'CASE 3E: Too Long and torturous to try to implement currently
        CASE &H3F
             PRINT "AAS"
        CASE &H40 TO &H5F
             Temp% = Map1D22DX(ASC(Byte) - &H40, 8)
             PRINT IncDec$(Map1D22DY(ASC(Byte) - &H40, Temp%, 8)) + "  " + RegSet$(1, Temp%)
        'CASE &H65 Not Known as a command
        CASE &H73
             GET 1, , Byte
             PRINT "JNB  " + HEX$(ASC(Byte)) + ";Relative jump"
         CASE &H75
             GET 1, , Byte
             PRINT "JNZ  " + HEX$(ASC(Byte)) + ";Relative jump"
        CASE &H77
             GET 1, , Byte
             PRINT "JA   " + HEX$(ASC(Byte)) + ";Relative jump"
        CASE &H81
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HFE
                         GET 1, , Integ%
                         PRINT "CMP SI, " + HEX$(Integ%)
                    CASE &HC4
                         GET 1, , Integ%
                         PRINT "ADD SP, " + HEX$(Integ%)
                    CASE ELSE
                    PRINT "81 " + HEX$(ASC(Byte))
             END SELECT
        CASE &H83
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HC3
                         GET 1, , Byte
                         PRINT "ADD BX, " + HEX$(ASC(Byte)) + ";Signed Byte"
                    CASE ELSE
                         PRINT "83 " + HEX$(ASC(Byte))
             END SELECT
        CASE &H89
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &H3E
                         GET 1, , Integ%
                         PRINT "MOV  [" + HEX$(Integ%) + "], DI"
                    CASE ELSE
                         PRINT "89 " + HEX$(ASC(Byte))
             END SELECT
        CASE &H8B
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &H36
                         GET 1, , Integ%
                         PRINT "MOV SI, [" + HEX$(Integ%) + "]"
                    CASE &HC8
                         PRINT "MOV CX, AX"
                    CASE &HE3
                         PRINT "MOV SP, BX"
                    CASE ELSE
                         PRINT "8B " + HEX$(ASC(Byte))
             END SELECT
        CASE &H8C
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HDA
                         PRINT "MOV  DX, DS"
                    CASE &HC8
                         PRINT "MOV  AX, CS"
                    CASE ELSE
                         PRINT "8C " + HEX$(ASC(Byte))
             END SELECT
        CASE &H8E
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HD7
                        PRINT "MOV SS, DI"
                    CASE ELSE
                        PRINT "8E " + HEX$(ASC(Byte))
             END SELECT
        CASE &H90
             PRINT "NOP"
        CASE &H98
             PRINT "CBW"
        CASE &HA0
             GET 1, , Integ%
             PRINT "MOV  AL,  [" + LongHex$(Integ%, 4) + "]"
        CASE &HA1
             GET 1, , Integ%
             PRINT "MOV  AX, [" + LongHex$(Integ%, 4) + "]"
        CASE &HA2
             GET 1, , Integ%
             PRINT "MOV  [" + LongHex$(Integ%, 4) + "], AL"
        CASE &HA3
             GET 1, , Integ%
             PRINT "MOV  [" + LongHex$(Integ%, 4) + "], AX"
        CASE &HB4
             GET 1, , Byte
             PRINT "MOV  AH," + HEX$(ASC(Byte))
             AX% = ASC("&H" + HEX$(ASC(Byte)) + LongHex(AX%, 2))
        CASE &HB8
             GET 1, , Integ%
             PRINT "MOV  AX, " + HEX$(Integ%)
             AX% = Integ%
        CASE &HB9
             GET 1, , Integ%
             PRINT "MOV  CX, " + HEX$(Integ%)
             AX% = Integ%
        CASE &HBA
             GET 1, , Integ%
             PRINT "MOV  DX, " + HEX$(Integ%)
             DX% = Integ%
        CASE &HBB
             GET 1, , Integ%
             PRINT "MOV  BX, " + HEX$(Integ%)
             BX% = Integ%
        CASE &HBC
             GET 1, , Integ%
             PRINT "MOV  SP, " + HEX$(Integ%)
             DX% = Integ%
        CASE &HBD
             GET 1, , Integ%
             PRINT "MOV  BP, " + HEX$(Integ%)
             DX% = Integ%
        CASE &HBE
            GET 1, , Integ%
            PRINT "MOV  SI, " + HEX$(Integ%)
            SI% = Integ%
        CASE &HBF
            GET 1, , Integ%
            PRINT "MOV  DI, " + HEX$(Integ%)
            DI% = Integ%
        CASE &HC7
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &H6
                        GET 1, , Integ%
                        PRINT "MOV   [" + HEX$(Integ%);
                        GET 1, , Integ%
                        PRINT "], " + HEX$(Integ%)
                    CASE ELSE
                        PRINT "C7 " + HEX$(ASC(Byte))
             END SELECT
        CASE &HCD
             GET 1, , Byte
             PRINT "INT " + HEX$(ASC(Byte))
        CASE &HCE
             PRINT "INTO"
        CASE &HD1
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HEB
                         PRINT "SHR   BX, 1"
                    CASE ELSE
             END SELECT
        CASE &HE9
             GET 1, , Integ%
             PRINT "JMP  " + LongHex(Integ%, 4)
        CASE &HF2
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HAE
                         PRINT "REPNE  SCASB"
                     CASE ELSE
                     PRINT "F2 " + HEX$(ASC(Byte))
             END SELECT
        CASE &HF3
             GET 1, , Byte
             SELECT CASE ASC(Byte)
                    CASE &HA4
                         PRINT "REP  MOVSB"
                    CASE &HA6
                         PRINT "REPZ CMPSB"
                    CASE ELSE
                    PRINT "F3 " + HEX$(ASC(Byte))
             END SELECT
        CASE &HFA
             PRINT "CLI"
        CASE &HFB
             PRINT "STI"
        CASE &HFC
             PRINT "CLD"
        CASE ELSE
            PRINT HEX$(ASC(Byte))
 END SELECT

Parse1Data:
DATA BX + SI,BX + DI,BP + SI,BP + DI, SI, DI, BP, BX



FUNCTION FormatInt$ (IntInt%, Format%)
END FUNCTION

FUNCTION FormatLong$ (LongLong&, Format%)
END FUNCTION

FUNCTION LongHex$ (Value%, Length%)
    TString$ = HEX$(Value%)
    Temp% = LEN(TString$)
    SELECT CASE Temp%
           CASE 0
           LongHex$ = STRING$(Length%, "0")
           CASE IS >= Length%
           LongHex$ = RIGHT$(TString$, Length%)
           CASE IS < Length%
                LongHex$ = STRING$(Length - Temp%, "0") + TString$
           CASE ELSE
           PRINT "Error In Subroutine LongHex, Value="; Value%; "Length="; Length%
    END SELECT
END FUNCTION

FUNCTION Parse1$ (ByteInt%, IntInt%)
    RESTORE Parse1Data
    FOR i% = 0 TO ByteInt%
        READ A$
    NEXT i%
    IF ByteInt% = 6 THEN A$ = LongHex$(IntInt%, 4)
    Parse1$ = "[" + A$ + "]"
END FUNCTION

